Imports System.Runtime.InteropServices
Imports System.Reflection

Public Class Form1

    Private Sub buttonMethod1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMethod1.Click
        statusLabel1.Text = String.Empty
        Dim addinInstance As Object = GetAddinObject()
        If addinInstance IsNot Nothing Then
            Try
                Dim value As Object = addinInstance.GetType().InvokeMember("Method1", BindingFlags.InvokeMethod, Nothing, addinInstance, New Object() {})
                MessageBox.Show(value.ToString())
            Finally
                Marshal.ReleaseComObject(addinInstance)
            End Try
        End If
    End Sub

    Private Sub buttonMethod2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMethod2.Click
        statusLabel1.Text = String.Empty
        Dim addinInstance As Object = GetAddinObject()
        If addinInstance IsNot Nothing Then
            Try
                Dim value As Object = addinInstance.GetType().InvokeMember("Method2", BindingFlags.InvokeMethod, Nothing, addinInstance, New Object() {})
                MessageBox.Show(value.ToString())
            Finally
                Marshal.ReleaseComObject(addinInstance)
            End Try
        End If
    End Sub

    Private Sub buttonMethod3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonMethod3.Click
        statusLabel1.Text = String.Empty
        Dim addinInstance As Object = GetAddinObject()
        If addinInstance IsNot Nothing Then
            Try
                Dim value As Object = addinInstance.GetType().InvokeMember("Method3", BindingFlags.InvokeMethod, Nothing, addinInstance, New Object() {})
                MessageBox.Show(value.ToString())
            Finally
                Marshal.ReleaseComObject(addinInstance)
            End Try
        End If
    End Sub

    Private Sub buttonGetProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonGetProperty.Click
        statusLabel1.Text = String.Empty
        Dim addinInstance As Object = GetAddinObject()
        If addinInstance IsNot Nothing Then
            Try
                Dim value As Object = addinInstance.GetType().InvokeMember("Prop", BindingFlags.GetProperty, Nothing, addinInstance, New Object() {})
                MessageBox.Show(value.ToString())
            Finally
                Marshal.ReleaseComObject(addinInstance)
            End Try
        End If

    End Sub

    Private Sub buttonSetProperty_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles buttonSetProperty.Click
        statusLabel1.Text = String.Empty
        Dim addinInstance As Object = GetAddinObject()
        If addinInstance IsNot Nothing Then
            Try
                Dim value As Object = FormEnterValue.InputBox()
                addinInstance.GetType().InvokeMember("SetProperty", BindingFlags.InvokeMethod, Nothing, addinInstance, New Object() {value})
            Finally
                Marshal.ReleaseComObject(addinInstance)
            End Try
        End If
    End Sub

    Private Function GetAddinObject() As Object
        Dim app As Excel._Application = Nothing
        Try
            app = CType(Marshal.GetActiveObject("Excel.Application"), Excel._Application)
        Catch
            statusLabel1.Text = "Excel is not running."
        End Try
        If app IsNot Nothing Then
            Try
                Dim addins As Office.COMAddIns = app.COMAddIns
                If addins IsNot Nothing Then
                    Try
                        ' ProgID of our add-in
                        Dim index As Object = "ExcelAddin_VB.AddinModule"
                        Dim addin As Office.COMAddIn = Nothing
                        Try
                            addin = addins.Item(index)
                        Catch
                            statusLabel1.Text = "COM add-in is not registered."

                        End Try
                        If addin IsNot Nothing Then
                            Try
                                If (addin.Connect) Then
                                    Return addin.Object
                                Else
                                    statusLabel1.Text = "COM add-in is not enabled."
                                End If
                            Finally
                                Marshal.ReleaseComObject(addin)
                            End Try
                        End If
                    Finally
                        Marshal.ReleaseComObject(addins)
                    End Try
                End If
            Finally
                Marshal.ReleaseComObject(app)
            End Try
            Return Nothing
        End If
    End Function
End Class
